/******************************************************************************
*
* (c) 2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Disclaimer: This program is an example and should be used as such.
*             If you wish to use this program or parts of it in your application,
*             you must validate the code yourself. BECK IPC GmbH can not be held
*             responsible for the correct functioning or coding of this example.
*
* Module:     main.c
* Function:   Example of a ASP like CGI Handler. ACP stands for Active Chip Pages.
*             The beck_acp program installs a CGI handler that can be used to
*             interpret scripts in html pages before serving them to the browser.
*             This enables you to provide the browser with a content that changes
*             according to the state of the I/O.
*
*             The syntax used is described in a PDF file in this directory.
* Notes:      It is advised to set the webserver stack to a minimum of 5000 bytes
*             in the chip.ini file.
*
*******************************************************************************
*
* $Header: c:\proj2000\IPC@CHIP\Examples\cgi\ACP\MAIN.C, 3, 31.03.2004 11:15:49, Andre Pribil$
*
******************************************************************************/


/******************************************************************************
* Includes
******************************************************************************/
#include <stdio.h>
#include "clib.h"
#include "beck_acp.h"



/******************************************************************************
* error_handler()
******************************************************************************/
#pragma argsused
void huge _pascal error_handler(int errorcode)
{
   BIOS_Reboot();
}



/******************************************************************************
* main()
******************************************************************************/
void main(int argc, char *argv[])
{
   int rslt;
   
   //installing user errorhandler
   BIOS_Install_Error_Handler ( error_handler );

   if (argc == 2)
   {
      rslt = acp_install(argv[1], "ACP");
      if (rslt == 0)
         printf("\nCGI handler successfully installed: ACP\n");
   }

   if (argc == 3)
   {
      rslt = acp_install(argv[1], argv[2]);
      if (rslt == 0)
         printf("\nCGI handler successfully installed: %s\n", argv[2]);
   }

   if (argc == 1)
   {
      printf("\nWrong usage:\n");
      printf("\nPlease use as followed: beck_acp.exe <module> <cgiName>");
      printf("\n<module> = \"dk40\" or \"bc440\"");
      printf("\n<cgiName> = your cgi name (if none: default = ACP)");
      printf("\n");
      return;
   }

   if (rslt != 0)
   {
      printf("\nError during CGI install!\n");
      return;
   }

   while(1)
   {
      api_sleep(1000);
   }
}



// End of file

