/******************************************************************************
*
* (c) 2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Disclaimer: This program is an example and should be used as such.
*             If you wish to use this program or parts of it in your application,
*             you must validate the code yourself. BECK IPC GmbH can not be held
*             responsible for the correct functioning or coding of this example.
*
* Module:     cfgip.c
* Function:   This program demonstrates the usage of the TCP/IP-API of the IPC@Chip.
*             The IP configuration is changed and checked severa times.
* Notes:      You need a DHCP-server on your network to run this program.
*
*******************************************************************************
*
* $Header: CFGIP.C, 3, 31.03.2004 11:15:34, Andre Pribil$
*
******************************************************************************/

/******************************************************************************
* Includes
******************************************************************************/
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <clib.h>



/******************************************************************************
* Global variables
******************************************************************************/
unsigned long testip;

char ip[16];
char gateway[16];
char mask[16];

char new_ip[16];
char new_gateway[16];
char new_mask[16];

unsigned int dhcp_use;
unsigned int dhcp_stat;

/******************************************************************************
* main()
******************************************************************************/
int main(void)
{

   int result;
   int timeout;
   unsigned char key=0;
   int old_dhcp_use;

   //switch stdio to our own program
   BIOS_Set_Focus( FOCUS_APPLICATION );


   printf("\r\n\r\nSC12 IP configuration demo");
   /*******************************************************************/
   //reading current ip configuration
   /*******************************************************************/
   Get_IPConfig(ip,mask,gateway);
   Get_DHCP_Status(&dhcp_use, &dhcp_stat);
   old_dhcp_use = dhcp_use;
   printf("\r\n\r\nCurrent configuration:");
   printf("\r\nIP      %s",ip);
   printf("\r\nMask    %s",mask);
   printf("\r\nGateway %s",gateway);
   printf("\r\nDHCP use %d DHCP stat %d",dhcp_use,dhcp_stat);


   printf("\r\n\r\nPress Enter to continue");
   while(key!=13)key=getch();

   /*******************************************************************/
   //Set new ip configuration
   /*******************************************************************/
   strcpy(new_ip,"192.168.200.15");
   strcpy(new_mask,"255.255.255.192");
   strcpy(new_gateway,"192.168.200.10");


   printf("\r\n\r\nNew configuration:");
   printf("\r\nIP      %s",new_ip);
   printf("\r\nMask    %s",new_mask);
   printf("\r\nGateway %s\r\nDHCP: 0",new_gateway);

   Set_IPConfig(new_ip, new_mask, new_gateway);
   //clear strings
   strcpy(new_ip,"0.0.0.0");
   strcpy(new_mask,"0.0.0.0");
   strcpy(new_gateway,"0.0.0.0");


   printf("\r\nReconfiguring ethernet interface");
   result=Reconfigure_ethernet();

   if(result==0)
   {
       Get_IPConfig(new_ip,new_mask,new_gateway);
       Get_DHCP_Status(&dhcp_use, &dhcp_stat);
       printf("\r\n\r\nGet new configuration:");
       printf("\r\nIP      %s",new_ip);
       printf("\r\nMask    %s",new_mask);
       printf("\r\nGateway %s",new_gateway);
       printf("\r\nDHCP use %d DHCP stat %d",dhcp_use,dhcp_stat);
   }
   else
   {
      printf("\r\nReconfigure failed\r\n");
      goto PROG_EXIT;

   }


   printf("\r\n\r\nPress Enter to continue");
   key=0;
   while(key!=13)key=getch();

   /*******************************************************************/
   //Testing DHCP
   /*******************************************************************/

   printf("\r\nReconfigure ethernet with DHCP enabled");
   DHCP_use(1);


   result=Reconfigure_ethernet();

   if(result==0)
   {
       printf("\r\nWaiting for DHCP config .");
       timeout=0;
       dhcp_stat=0;
       while(dhcp_stat==0)
       {
          Get_DHCP_Status(&dhcp_use, &dhcp_stat);
          if(timeout++>25) break;//seconds
          RTX_Sleep_Time(1000);
          printf(".");

       }

       //clear strings
       strcpy(new_ip,"0.0.0.0");
       strcpy(new_mask,"0.0.0.0");
       strcpy(new_gateway,"0.0.0.0");

       Get_IPConfig(new_ip,new_mask,new_gateway);
       Get_DHCP_Status(&dhcp_use, &dhcp_stat);
       printf("\r\n\r\nGet new SC12 IP configuration\r\n");
       printf("\r\nIP      %s",new_ip);
       printf("\r\nMask    %s",new_mask);
       printf("\r\nGateway %s",new_gateway);
       printf("\r\nDHCP use %d DHCP stat %d",dhcp_use,dhcp_stat);
   }
   else
   {
      printf("\r\nReconfigure failed\r\n");


   }

PROG_EXIT:

   printf("\r\n\r\nPress Enter to continue");
   key=0;
   while(key!=13)key=getch();

   printf("\r\n\r\nRestore old IP configuration ");

   if(old_dhcp_use==1)
   {
     DHCP_use(1);
   }
   else
   {
     DHCP_use(0);
     Set_IPConfig(ip,mask,gateway);
   }

  result=Reconfigure_ethernet();

  if(result==0)
  {
      if(old_dhcp_use==1)
      {
        printf("\r\nWaiting for DHCP config .");
        timeout=0;
        dhcp_stat=0;
        while(dhcp_stat==0)
        {
             Get_DHCP_Status(&dhcp_use, &dhcp_stat);
             if(timeout++>25) break;//seconds
             RTX_Sleep_Time(1000);
             printf(".");

        }
      }
  }
  else
  {
     printf("\r\n Restore failed\r\n");
  }

  printf("\r\nExit program\r\n\r\n");
  //switch stdio to shell
  BIOS_Set_Focus( FOCUS_BOTH );
  return 0;
}


