/******************************************************************************
*
* (c) 2003-2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Module:   ftplib.h
* Function: See ftplib.c
*
*******************************************************************************
*
* $Header: ftplib.h, 1, 08.04.2004 13:36:08, Jan Schatz$
*
******************************************************************************/



#ifndef _FTPLIB_H_
#define _FTPLIB_H_



#include "bool.h"



/******************************************************************************
* Constants
******************************************************************************/
#define FTP_PORT         21     // FTP port for control connection
#define FTP_SIZE_LINE    256    // Size of one command or reply line in bytes
#define FTP_SIZE_BUFFER  1024   // Size for buffers (e.g. for file
                                // transfer) in bytes
#define FTP_TIMEOUT      10000  // (milliseconds) Timeout value for communication



/******************************************************************************
* Definition of types
******************************************************************************/
typedef enum {
               FTP_TYPE_ASCII_NONPRINT,
               //FTP_TYPE_ASCII_TELNET,     not supported
               //FTP_TYPE_ASCII_ASA,        not supported
               //FTP_TYPE_EBCDIC_NONPRINT,  not supported
               //FTP_TYPE_EBCDIC_TELNET,    not supported
               //FTP_TYPE_EBCDIC_ASA,       not supported
               FTP_TYPE_IMAGE,
               //FTP_TYPE_LOCALBYTESIZE     not supported
             } FTP_TYPE;




/******************************************************************************
* Prototypes
******************************************************************************/
int ftpOpenControlConnection(
                              const char *remoteIp );
BOOL ftpLogin(
  int controlSocket,
  const char *user,
  const char *password,
  const char *account );
BOOL ftpLogout(
  int controlSocket );
BOOL ftpListDirectory(
  int controlSocket,
  const char *directory,
  FILE *destination,
  BOOL passive );
BOOL ftpCreateDirectory(
  int controlSocket,
  const char *directory );
BOOL ftpDeleteDirectory(
  int controlSocket,
  const char *directory );
BOOL ftpSetDirectory(
  int controlSocket,
  const char *directory );
BOOL ftpGetDirectory(
  int controlSocket,
  char *directory );
BOOL ftpSendFile(
  int controlSocket,
  const char *filenameRemote,
  const char *filenameLocal,
  FTP_TYPE type,
  BOOL passive );
BOOL ftpReceiveFile(
  int controlSocket,
  const char *filenameLocal,
  const char *filenameRemote,
  FTP_TYPE type,
  BOOL passive );
BOOL ftpDelete(
  int controlSocket,
  const char *filename );
BOOL ftpRename(
  int controlSocket,
  const char *filenameNew,
  const char *filenameOld );



#endif  // #ifndef _FTPLIB_H_

