/******************************************************************************
*
* (c) 2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Disclaimer: This program is an example and should be used as such.
*             If you wish to use this program or parts of it in your application,
*             you must validate the code yourself. BECK IPC GmbH can not be held
*             responsible for the correct functioning or coding of this example.
*
* Module:     pkt_cnt.c
* Function:   This program demonstrates the usage of the TCP/IP-API of the IPC@Chip.
*             It counts all incoming and outgoing network packages and shows a
*             statistic after 10 seconds. Then the user can restart counting or
*             exit the program.
*
*******************************************************************************
*
* $Header: PKT_CNT.C, 3, 31.03.2004 11:15:52, Andre Pribil$
*
******************************************************************************/

/******************************************************************************
* Includes
******************************************************************************/
#include <stdio.h>
#include <conio.h>
#include <clib.h>

/******************************************************************************
* Global variables
******************************************************************************/
Packet_Count  save_pkt_cnt;

/******************************************************************************
* main()
******************************************************************************/
int main(void)
{

   int i;
   int key=0;

   Packet_Count * pkt_cnt; /* struct Packet_Count is defined at tcpipapi.h*/

   //switch stdio to our own program
   BIOS_Set_Focus( FOCUS_APPLICATION );
   printf("\r\n\r\nIPC@Chip Counting network packets");
   /******************************************************************/
   //Get pointer to the IPC@Chip internal packet count structure
   /******************************************************************/
   Get_TCPIP_Statistics(&pkt_cnt);

   while(key!=27)
   {
      /******************************************************************/
      //Reset all counters
      /******************************************************************/
      /*receive counters*/
      *(pkt_cnt->cnt_all_packets)=0;
      *(pkt_cnt->cnt_ip_packets)=0;
      *(pkt_cnt->cnt_arp_packets)=0;
      *(pkt_cnt->cnt_tcp_packets)=0;
      *(pkt_cnt->cnt_udp_packets)=0;
      *(pkt_cnt->cnt_icmp_packets)=0;
      /*send counters*/
      *(pkt_cnt->cnt_all_sended_packets)=0;
      *(pkt_cnt->cnt_ip_sended_packets)=0;
      *(pkt_cnt->cnt_arp_sended_packets)=0;
      *(pkt_cnt->cnt_udp_sended_packets)=0;
      *(pkt_cnt->cnt_tcp_sended_packets)=0;
      *(pkt_cnt->cnt_icmp_sended_packets)=0;

      /*chksum error counters*/
      *(pkt_cnt->cnt_ip_chksum_errs)=0;
      *(pkt_cnt->cnt_udp_chksum_errs)=0;
      *(pkt_cnt->cnt_tcp_chksum_errs)=0;
      *(pkt_cnt->cnt_eth_errs)=0;

      /******************************************************************/
      //Sleep 10 seconds
      /******************************************************************/
      printf("\r\nSleeping ");
      for(i=0;i<20;i++)
      {
         putchar('.');
         RTX_Sleep_Time(500);
      }
      /******************************************************************/
      //Reading counters
      /******************************************************************/
      /*received packets*/
      printf("\r\nReceived  %05u after 10 seconds",*(pkt_cnt->cnt_all_packets));
      printf("\r\nIP      %05u", *(pkt_cnt->cnt_ip_packets));
      printf("\r\nARP     %05u", *(pkt_cnt->cnt_arp_packets));
      printf("\r\nUDP     %05u", *(pkt_cnt->cnt_udp_packets));
      printf("\r\nTCP     %05u", *(pkt_cnt->cnt_tcp_packets));
      printf("\r\nICMP    %05u\r\n", *(pkt_cnt->cnt_icmp_packets));

      /*sent packets*/
      printf("\r\nSent    %05u after 10 seconds",*(pkt_cnt->cnt_all_sended_packets));
      printf("\r\nIP      %05u", *(pkt_cnt->cnt_ip_sended_packets));
      printf("\r\nARP     %05u", *(pkt_cnt->cnt_arp_sended_packets));
      printf("\r\nUDP     %05u", *(pkt_cnt->cnt_udp_sended_packets));

      /*important:
       If you use Telnet as stdio channel, your tcp counter will now have a
       higher value, because of this printf calls
      */
      printf("\r\nTCP     %05u", *(pkt_cnt->cnt_tcp_sended_packets));
      printf("\r\nICMP    %05u\r\n", *(pkt_cnt->cnt_icmp_sended_packets));

      /*chksum errors on incoming packets*/
      printf("\r\nChecksum errors");
      printf("\r\nIP       %05u", *(pkt_cnt->cnt_ip_chksum_errs));
      printf("\r\nUDP      %05u", *(pkt_cnt->cnt_udp_chksum_errs));
      printf("\r\nTCP      %05u", *(pkt_cnt->cnt_tcp_chksum_errs));
      printf("\r\nEthernet %05u", *(pkt_cnt->cnt_eth_errs));

      printf("\r\nPress any key to continue, ESC exits\r\n");
      key=getch();


  }


  printf("\r\nExit program\r\n\r\n");
  BIOS_Set_Focus( FOCUS_BOTH );
  return 0;
}


