/******************************************************************************
*
* (c) 2004 by BECK IPC GmbH
*
* BECK IPC GmbH
* Garbenheimerstr. 36-38
* D-35578 Wetzlar
*
* Phone: (49)-6441-905-0
* Fax:   (49)-6441-905-245
*
*******************************************************************************
*
* Disclaimer: This program is an example and should be used as such.
*             If you wish to use this program or parts of it in your application,
*             you must validate the code yourself. BECK IPC GmbH can not be held
*             responsible for the correct functioning or coding of this example.
*
* Module:     main.c
*             Requires SC13 @CHIP-RTOS V0.91 or SC12 @CHIP-RTOS V1.10 or higher
* Function:   Entrypoint: Init and starting  SNMPV1 Proxy agent
*             For more information see readme.txt at the Doc directory
*
*******************************************************************************
*
* $Header: main.c, 2, 31.03.2004 11:15:49, Andre Pribil$
*
*******************************************************************************/

/***************************************************************************
* Includes
***************************************************************************/
#include <DKXX.h>
#include <RTOS.H>
#include <snmpv1.h>
#include <snmphlp.h>
#include <bios_api.h>
#include <helper.h>

/***************************************************************************
* Defines
***************************************************************************/
#define AGENT_VERSION "V1.00"    //Current version number

#define TABLE_POLL  300          //Table poll * 100ms = polling interval


/***************************************************************************
* main: Initialize and start snmp proxy agent task
***************************************************************************/
int main(void)
{
   unsigned int mib_intv=1;
   int rslt=0;
   long sema_timeout=0L;

   if (init_snmp() !=0)
   {
       helper_printf("\r\nIPC@CHIP SNMP agent error");
       return 0;
   }

   helper_printf("\r\nIPC@CHIP SNMP proxy agent %s",(char far *)AGENT_VERSION);

   while(1)
   {
       RTX_Sleep_Time(100);
       //+++++++++++++++++   rebuild dynamic tables   ++++++++++++++++++++
       if(mib_intv--==0)
       {
           sema_timeout=0L;
           RTX_Wait_Sem(mib_semaphoreID, &sema_timeout);
           rslt=build_dynamic_mib_tables();
           RTX_Signal_Sem(mib_semaphoreID);
           mib_intv=TABLE_POLL;
           if(rslt==-1)
           {
              helper_printf("\r\nFatal memory allocation error");
           }
       }

       #ifdef DKXX_SNMP_DEMO
       //Read output 7 of DK40 IO port and set a trap if output is high
       if(get_dkxx_bit(7))
       {
          send_SNMP_trap(SNMP_TRAP_ENTERPRISESPECIFIC, DKXX_TRAP_O_7);
          //To avoid endless sending of this trap, reset DKxx output 7
          set_dkxx_bit(7, 0 );
       }
       #endif
   }
}
/****************************************************************************/
//end main.c

